package nl.amis.als;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;

import java.util.Comparator;

import java.util.List;

import nl.amis.als.view.jsf.FindBookBackingBean;

public class LibraryManager {

    Collection library = new ArrayList<Book>(50);
    Book queryConditions = null;
    
    public LibraryManager() {
    /* title publicationYear author subjects publisher
    , isbn homepage) */
     library.add(new Book("JavaServer Faces in Action", 2004,"Kito D. Mann","Java Server Faces, J2EE","Manning Publications Co.","1932394125","http://www.manning.com/mann/"));
        library.add(new Book("Hibernate in Action", 2004,"Christian Bauer and Gavin King","Hibernate, Object Relational Mapping, J2EE","Manning Publications Co.","193239415X","http://www.manning.com/bauer/"));
        library.add(new Book("Ajax in Action", 2005,"David Crane","Web, AJAX, JavaScript","Manning Publications Co.","1932394613","http://www.manning.com/crane/"));
        library.add(new Book("Art of Java Web Development", 2003,"Neal Ford","Web, Struts, Tapestry, J2EE","Manning Publications Co.","1932394060","http://www.manning.com/ford/"));
        library.add(new Book("Pro JSF and Ajax: Building Rich Internet Components", 2005,"Jonas Jacobi and John Fallows","JSF, AJAX, J2EE","APress","1590595807","http://www.apress.com/book/bookDisplay.html?bID=10044"));
        library.add(new Book("Foundations of Ajax", 2005,"Ryan Asleson, Nathaniel T. Schutta","Ajax, JavaScript, Web","APress","1590595823","http://www.apress.com/book/bookDisplay.html?bID=10042/"));
        library.add(new Book("Beginning POJOs: From Novice to Professional", 2004,"Brian Sam-Bodden","Java, J2EE","APress","1590595963","http://www.apress.com/book/bookDisplay.html?bID=10059"));
        library.add(new Book("Cost-Based Oracle Fundamentals", 2005,"Jonathan Lewis","Oracle, Performance Tuning","APress","1590596366","http://www.apress.com/book/bookDisplay.html?bID=10081"));
        library.add(new Book("Expert Oracle Database Architecture: 9i and 10g Programming Techniques and Solutions", 2005,"Tom Kyte","Oracle, Architecture,","APress","1590595300","http://www.apress.com/book/bookDisplay.html?bID=10008"));
        library.add(new Book("Expert Oracle Database 10g Administration", 2005,"Sam R. Alapati","Oracle, DBA","APress","1590594517","http://www.apress.com/book/bookDisplay.html?bID=411"));
        library.add(new Book("Mastering Oracle SQL and SQL*Plus", 2005,"Lex de Haan","Oracle, SQL","APress","1590594487","http://www.apress.com/book/bookDisplay.html?bID=385"));
        library.add(new Book("Oracle Application Server 10g: J2EE Deployment and Administration", 2005,"Rob Harrop, Jan Machacek, Erin Mulder, Michael Wessler","Oracle, Application Server, J2EE","APress","1590592352","http://www.apress.com/book/bookDisplay.html?bID=236"));

        library.add(new Book("Head First Java, Second Edition", 2005,"Kathy Sierra, Bert Bates","Java, J2SE","O'Reilly","0-596-00920-8","http://www.oreilly.com/catalog/hfjava2/"));
        library.add(new Book("Head First HTML with CSS & XHTML", 2005,"Elisabeth Freeman, Eric Freeman","Web, HTML, CSS","O'Reilly","0-596-10197-X","http://www.oreilly.com/catalog/hfhtmlcss/"));
        library.add(new Book("JavaServer Faces", 2004,"Hans Bergsten","Java Server Faces, J2EE","O'Reilly","0-596-00539-3","http://www.oreilly.com/catalog/jsvrfaces/"));
        library.add(new Book("Wicked Cool Java ", 2005,"Brian D. Eubanks","Java","O'Reilly","1-59327-061-5","http://www.oreilly.com/catalog/1593270615/"));
        library.add(new Book("Hibernate: A Developer's Notebook", 2004,"James Elliott","Hibernate, Object Relational Mapping, Java, J2EE","O'Reilly","0-596-00696-9","http://www.oreilly.com/catalog/hibernate/"));
        library.add(new Book("Atlas: Rough Cuts Version", 2006,"Christian Wenz","Ajax, Web","O'Reilly","0-596-52716-0","http://www.oreilly.com/catalog/atlas/?CMP=ILC-GG7423313304&ATT=atlas"));
        library.add(new Book("Ruby on Rails: Up and Running: Rough Cuts Version", 2006,"Bruce A. Tate, Curt Hibbs","Ruby,On Rails, Web","O'Reilly","0-596-52710-1","http://www.oreilly.com/catalog/rubyrails/"));
    }
    
    private boolean satisfiesQuery(Book book, Book queryConditions) {
      boolean result = true;
        if (queryConditions.getPublicationYear()!=null) 
            result = ((result) && (book.getPublicationYear() >= queryConditions.getPublicationYear()));
        if (queryConditions.getTitle()!=null) 
            result = ((result) && (book.getTitle().toLowerCase().indexOf( queryConditions.getTitle().toLowerCase()) >-1));
        if (queryConditions.getAuthor()!=null) 
            result = ((result) && (book.getAuthor().toLowerCase().indexOf( queryConditions.getAuthor().toLowerCase()) >-1));
      
      return result;
    }
    
   
    
    public Collection<Book> getBooks() {
      if (queryConditions==null) {
        return this.library;
      }
      else {
          Collection books = new ArrayList<Book>(this.library.size());
          for(Book b: (Collection<Book>)this.library) {
             if (satisfiesQuery( b, queryConditions))
               books.add(b);
          }
          return books;                
      }
    }

    public void setQueryConditions(Book queryConditions) {
        this.queryConditions = queryConditions;
    }

    public Book getQueryConditions() {
        return queryConditions;
    }


}
