package nl.amis.als.view.jsf;

import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.component.UIInput;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.event.ValueChangeEvent;

import nl.amis.als.Book;
import nl.amis.als.LibraryManager;

public class FindBookBackingBean {
    LibraryManager libraryMgr ;
    Book bookSearch;
    public FindBookBackingBean() {
    }
    public String getTitlePrompt() {
        return "Title to search for";
    }
    
    public String getTitleBubble() {
        return "Enter a string that you want books to have in their title; this is case insensitive";
    }

    public void changeAuthor(ValueChangeEvent valueChangeEvent) {
      FacesContext fc = FacesContext.getCurrentInstance();
       fc.addMessage(valueChangeEvent.getComponent().getClientId(fc) 
       , new FacesMessage("Changed value of Author; Old value was: " + valueChangeEvent.getOldValue()));
    }

    // When the Search button is pressed, we want to set the current
    // bookSearch bean as queryCondition on the LibraryManager. We then return
    // find as the action outcome
    public String doSearch() {
        FacesContext fc = FacesContext.getCurrentInstance();
        // find the bookSearch bean
        libraryMgr.setQueryConditions(bookSearch); 
        return "search";
    }
    
    // When the All Books button is pressed, we want to set an empty
    // queryCondition on the LibraryManager. We then return
    // search as the action outcome
    public String doShowAll() {
        FacesContext fc = FacesContext.getCurrentInstance();
        // find the bookSearch bean
        libraryMgr.setQueryConditions(null);       
        return "showAll";
    }

    public void subject_validator(FacesContext facesContext, 
                                  UIComponent uiComponent, Object object) {
        if (((String[])object).length > 3) {
          ((UIInput)uiComponent).setValid(false);
          FacesMessage message = new FacesMessage("No more than three topics please!");
          facesContext.addMessage(uiComponent.getClientId(facesContext), message);    
        }
    }

    public void setLibraryMgr(LibraryManager libraryMgr) {
        this.libraryMgr = libraryMgr;
    }

    public LibraryManager getLibraryMgr() {
        return libraryMgr;
    }

    public void setBookSearch(Book bookSearch) {
        this.bookSearch = bookSearch;
    }

    public Book getBookSearch() {
        return bookSearch;
    }

    
   

}
